﻿using Avalonia;
using Avalonia.Controls.ApplicationLifetimes;
using Avalonia.Platform.Storage;
using ReactiveUI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using Users_Roles.Models;
using MsBox.Avalonia.Enums;
using MsBox.Avalonia;

namespace Users_Roles.ViewModels
{
    internal class AddUserVM : ViewModelBase
    {
        string _messageButton;
        User? _newUser;
        public User? NewUser { get => _newUser; set => this.RaiseAndSetIfChanged(ref _newUser, value); }

        public AddUserVM(int idRole)
        {
            _newUser = new User();
            _newUser.RoleUser = idRole;
            if (idRole == 1)
            {
                MessageButton = "Зарегистрировать администратора";
            }
            else
            {
                MessageButton = "Зарегистрировать пользователя";
            }
        }

        string _massege;
        string _newPassword;
        public string NewPassword { get => _newPassword; set => _newPassword = value; }
        public string Massege { get => _massege; set => this.RaiseAndSetIfChanged(ref _massege, value); }
        public string MessageButton { get => _messageButton; set => _messageButton = value; }

        bool TruePassword()
        {
            bool flag = false;
            Massege = "";

            Regex _newPasswordRegex1 = new Regex("\\w{8,}");
            Regex _newPasswordRegex2 = new Regex("[0-9]");
            Regex _newPasswordRegex3 = new Regex("[A-Z]");
            Regex _newPasswordRegex4 = new Regex("[a-z]");
            Regex _newPasswordRegex5 = new Regex("^[0-9]");

            if (NewPassword == null || NewPassword == "")
            {
                Massege = "Пароль не может быть пустым\n";
                flag = true;
                return flag;
            }
            if (!_newPasswordRegex1.IsMatch(NewPassword))
            {
                Massege += "Пароль должен состоять из 8 и более символов\n";
                flag = true;
            }
            if (_newPasswordRegex2.Count(NewPassword) < 2)
            {
                Massege += "Пароль должен состоять 2 и более цифр\n";
                flag = true;
            }
            if (_newPasswordRegex3.Count(NewPassword) < 2)
            {
                Massege += "Пароль должен состоять из 2 и более заглавных латинских сиволов\n";
                flag = true;
            }
            if (_newPasswordRegex4.Count(NewPassword) < 3)
            {
                Massege += "Пароль должен состоять из 3 и более строчных латинских сиволов\n";
                flag = true;
            }
            if (_newPasswordRegex5.IsMatch(NewPassword))
            {
                Massege += "В пароле 1 символ не должен быть цифрой\n";
                flag = true;
            }
            return flag;
        }

        public async Task AddOnePhoto()
        {
            if (Application.Current?.ApplicationLifetime is not IClassicDesktopStyleApplicationLifetime desctop || desctop.MainWindow?.StorageProvider is not { } provider) throw new NullReferenceException("Провайдер отсутствует");

            var file = await provider.OpenFilePickerAsync(
                new FilePickerOpenOptions()
                {
                    Title = "Выберите изображение",
                    AllowMultiple = false,
                    FileTypeFilter = [FilePickerFileTypes.All, FilePickerFileTypes.ImageAll]
                }
                );
            if (file != null)
            {
                await using var readStream = await file[0].OpenReadAsync();
                byte[] buffer = new byte[readStream.Length];
                readStream.ReadAtLeast(buffer, 1);
                NewUser.Image = buffer;
            }
        }
        public static _43pGaruaev2Context myConnection = new _43pGaruaev2Context();
        public void AddUser()
        {
            if (myConnection.Users.Any(x => x.Login == NewUser.Login))
            {
                Massege = "Пользователь с таким логином уже существует";
            }
            else if (TruePassword())
            {
                
            }
            else
            {
                if (_newUser == null)
                {
                    _newUser = new User();
                }
                if (_newPassword != string.Empty)
                {
                    NewUser.Pasword = MD5.HashData(Encoding.ASCII.GetBytes(NewPassword));
                }

                MainWindowViewModel.myConnection.Users.Add(NewUser);

                MainWindowViewModel.myConnection.SaveChanges();

                MessageBoxManager.GetMessageBoxStandard("Добавление", "Вы зарегистрировались", ButtonEnum.Ok).ShowAsync();

                MainWindowViewModel.Instance.PageContent = new PageRegistrationV();
            }
        }

    }

}
