﻿using Avalonia;
using Avalonia.Controls.ApplicationLifetimes;
using Avalonia.Platform.Storage;
using ReactiveUI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using Users_Roles.Models;
using MsBox.Avalonia.Enums;
using MsBox.Avalonia;
using Microsoft.EntityFrameworkCore;


namespace Users_Roles.ViewModels
{
    internal class ProfileVM : ViewModelBase
    {
        User _user;
        public ProfileVM(int UserID)
        {
            User = MainWindowViewModel.myConnection.Users.Include(x => x.RoleUserNavigation).FirstOrDefault(x => x.IdUser == UserID);
        }

        public User User { get => _user; set => _user = value; }

        public void Out()
        {
            MainWindowViewModel.Instance.PageContent = new PageRegistrationV();
        }

        public async Task AddOnePhoto()
        {
            if (Application.Current?.ApplicationLifetime is not IClassicDesktopStyleApplicationLifetime desctop || desctop.MainWindow?.StorageProvider is not { } provider) throw new NullReferenceException("Провайдер отсутствует");

            var file = await provider.OpenFilePickerAsync(
                new FilePickerOpenOptions()
                {
                    Title = "Выберите изображение",
                    AllowMultiple = false,
                    FileTypeFilter = [FilePickerFileTypes.All, FilePickerFileTypes.ImageAll]
                }
                );
            if (file != null)
            {
                await using var readStream = await file[0].OpenReadAsync();
                byte[] buffer = new byte[readStream.Length];
                readStream.ReadAtLeast(buffer, 1);
                User.Image = buffer;
            }

            MainWindowViewModel.myConnection.SaveChanges();
            MainWindowViewModel.Instance.PageContent = new ProfileV(User.IdUser);
        }
    }
}
